<?php
/*

Copyright (c)2002-2003 DuckCorp(tm) and RtpNet(tm)



This file is part of LMS.

LMS is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

LMS is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with LMS; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

error_reporting(0);

$version = "0.3.0";
$output_dir = "/var/lib/lms-subsys-ftpsearch/";

require("/etc/lms/main.php");
require("ldap.php");

if ( $config[xoops_output] )
{
	$result = "<?php
include('$config[xoops_path]/mainfile.php');
include_once(XOOPS_ROOT_PATH.'/class/xoopscomments.php');

if ( !\$xoopsUser ) {
	redirect_header('index.php',3,_US_NOEDITRIGHT);
	exit();
}

include(XOOPS_ROOT_PATH.'/header.php');
OpenTable();
echo \"
	";
}
else
{
	$result = "<html><body>";
}

$con = new LdapConnection();
$con->set_display_errors(true);
if ($con->connect($config[server], true))
{
	if ($con->bind($config[login], $config[passwd]))
	{
		$hosts = find_hosts($con, $config);
		if (count($hosts)>0)
		{
			$result.= "<CENTER>";
			$result.= "<H1>Servers FTP Actifs sur le LAN</H1>";
			$result.="<H2>Cette page est gnre et automatiquement rafraichie toutes les 10 min<BR>\n";
			$result.="(dernire mise  jour : ".date("Y-m-d H:i:s").")</H2>\n";
			$result.="<H3>\n";
			for ($i=0; $i<count($hosts); $i++)
			{
				//if (ftp_connect($hosts[$i][ip], 21, 1))
				if (ftp_connect($hosts[$i][ip], 21))
				{
					$result.="<A href='ftp://".$hosts[$i][hostname].".coinnetwork.dl/'>".$hosts[$i][hostname]."</A><BR>\n";
				}
			}
			$result.="</H3><BR><HR>\n";
			$result.="<H3>LMS FTPSEARCH-S V".$version." <BR> Copyright &copy;2002-2003 DuckCorp&#153; and RtpNet&#153;</H3>\n";
			$result.="<H4>This program is free software; you can redistribute it and/or modify it under the terms<BR>";
			$result.="of the GNU General Public License as published by the <A href='http://www.fsf.org/'>Free Software Foundation</A>.</H4>";
			$result.="</CENTER>";
			if ( $config[xoops_output] )
			{
				$result.="\";
				CloseTable();
				include(XOOPS_ROOT_PATH.'/footer.php');
				?>";
			}
			else
			{
				$result.="</body></html>";
			}

			$fp = fopen($output_dir."/index.php.build" ,"w");
			fwrite($fp, $result);
			fclose($fp);
			rename($output_dir."/index.php.build", $output_dir."/index.php");
		}
	}
	$con->disconnect();
}
unset($con);



function find_hosts($con, $config)
{
	$tab = array();
	$tabi = 0;

	$entries =& $con->search($config[base], "(|(objectclass=".$config[objectclass_commonhost].")(objectclass=".$config[objectclass_serverhost]."))");
	if ($entries)
	{
		$nb = $entries->get_count();
		if ($nb)
		{
			for ($i=0; $i<$nb; $i++)
			{
				$ent=$entries->get_entry($i);
				$nbip=$ent[iphostnumber][count];
				if ($nbip>0)
				{
					if ($ent[iphostnumber][0]!="0.0.0.0")
					{
						$tab[$tabi][hostname] = strtolower($ent[cn][0]);
						$tab[$tabi][ip] = $ent[iphostnumber][0];
						$tabi++;
					}
				}
			}

			return $tab;
		}
		else
			print("####### No Host found #######\n");
	}

	return null;
}

?>
